
; L8TM

PIO_A_DATA = 0x00
PIO_B_DATA = 0x01
PIO_A_CTRL = 0x02
PIO_B_CTRL = 0x03
SIO_A_DATA = 0x10
SIO_B_DATA = 0x11
SIO_A_CSR  = 0x12
SIO_B_CSR  = 0x13
TMR_BRG    = 0x20
TMR_LPF    = 0x21
TMR_MT     = 0x22
TMR_CTRL   = 0x23
DA_RFC     = 0x30
DA_TPC     = 0x40
OUT_2      = 0x50
OUT_0      = 0x60
BANK       = 0x70
AD_RSSI    = 0x80
AD_SQL     = 0x81
AD_BATT    = 0x82
AD_TPC     = 0x83
AD_FPM     = 0x84
AD_RPM     = 0x85
AD_TP4     = 0x86
AD_IN7     = 0x87
WDOG       = 0x90

O0_VOLUME = 0x07 ; speaker volume
O0_INH    = 0x08 ; speaker off
O0_AUDIOC = 0x10
O0_CCIRC  = 0x20
O0_MTC    = 0x40
O0_MICM   = 0x80

O2_DP     = 0x01 ; aka O1_SD
O2_CLK    = 0x02 ; aka O1_CLK
O1_SRE    = 0x04
O1_STE    = 0x08
O2_CS1    = 0x10
O2_CS2    = 0x20
O1_TPS    = 0x40
O1_TXOFF  = 0x80

O1_CLK  = O2_CLK
O1_SD   = O2_DP
OUT_1   = OUT_2


BNK_ROM1A14 = 0x01
BNK_ROM1A15 = 0x02
BNK_ROM0A15 = 0x04

PA_CLK2    = 0x01
PA_SCE     = 0x02
PA_WDR     = 0x04
PA_PWR     = 0x08
PA_CCIR    = 0xF0

PB_RAMA12 = 0x01
PB_EXIN1  = 0x02
PB_EXIN2  = 0x04
PB_DCU    = 0x08
PB_ROM_SL = 0x10
PB_SMEM   = 0x20
PB_EXAL   = 0x40
PB_PWROFF = 0x80

TMR_SEL_BRG  = 0x00
TMR_SEL_LPF  = 0x40
TMR_SEL_MT   = 0x80
TMR_INTTC    = 0x00
TMR_ONESHOT  = 0x02
TMR_RATEGEN  = 0x04
TMR_SQWAVE   = 0x06
TMR_SWTRIGG  = 0x08
TMR_HWTRIGG  = 0x0A
TMR_LATCH    = 0x00
TMR_LSB      = 0x10
TMR_MSB      = 0x20
TMR_BOTH     = 0x30


WR0_RESET_TXINT  = 0x28
WR0_RESET_ESCINT = 0x10
WR0_ERROR_RESET  = 0x30

MT8888_WD  = 0xC0  ; write data,    RS0=0, A1=0
MT8888_WC  = 0xC1  ; write control, RS0=1, A1=0
MT8888_RD  = 0xC2  ; read data,     RS0=0, A1=1
MT8888_RS  = 0xC3  ; read status,   RS0=1, A1=1

SA_HOOK   = 0x08
SA_DA     = 0x20	; DA or I2C /INT
SA_INT    = 0x20

SB_PTT    = 0x20
SB_LOCAL  = 0x10
SB_DMIDLE = 0x08	; 1 means MBUS idle

SB_MON    = 0x80   ; Master ON pulse, a/c coupled

