
#define MAGIC 0xD89B9ED2

typedef byte cfg_string[11];
typedef byte cfg_boolean;
typedef byte cfg_table;

struct cfg {
	dword magic;
	word size;

	dword rx_freq;
	dword tx_offset;

	byte volume;
	cfg_table af_dest;

	byte tpc;
	byte deviation; /* XXX _4_ bits in synth control 4094 */
	byte dtmf_gain;
	byte ccir_gain;
	byte afsk_gain;
	byte ctcss_gain;
	word lpf;

	byte sql_level;
	byte sql_bi_rssi;
	byte sql_hyst;
	word sql_open;
	word sql_close;
	cfg_table sql_method;

	byte lights;

	word ctcss;
	word ax_txdelay;

	cfg_string mycall;
	cfg_string id;

	cfg_table sio_a_fmt;
	cfg_table sio_b_fmt;

	cfg_boolean fdx;
	cfg_boolean stay_on;
	cfg_table dtmf_decoder;

	dword tx_band_start;
	dword tx_band_end;
	dword rx_band_center;
	dword tx_band_center;
	long if_offset;
	word prescaler;

	word batt_cutoff;

	word implied;

	word dcs;
};

extern struct cfg cfg; /* 0xC100 abs */

extern byte
	bbram[],           /* 0xC000 */
	cfg_START[],
	cfg_END[],
	rfc_table[256],    /* 0xCF00 */
	data[];            /* 0xD000 */

extern const word cfg_size;

extern void
	new_defaults(),
	full_reset();

/* 5v REF, 100k and 47k divider */

#define millivolt(ad) ((ad) * 61U)

struct memory {
	byte  flags;
	byte  reserved;
	word  ctcss;
	dword rx_freq;
	dword tx_offset;
};

extern struct memory memories[];

