
#include "head.h"
#include "cu.h"
#include "cfg.h"
#include "iomap.h"

/*
 *  "it really helps to stop and think"
 *
 *
 *  74C923, PCF2111T 2pcs and some shifters etc
 *
 *       display_1[6]
 *       display_2[10]
 *       scattered icons
 *  indicator and lighting leds
 */

static const byte font[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

	0x00,   /*       - - - -   - - - */
	0x79,   /* !     0 - - 3   4 5 6 */
	0x09,   /* "     0 - - 3   - - - */
	0x66,   /* #     - 1 2 -   - 5 6 */
	0x25,   /* $     0 - 2 -   - 5 - */
	0x05,   /* %     0 - 2 -   - - - */
	0x6A,   /* &     - 1 - 3   - 5 6 */
	0x08,   /* '     - - - 3   - - - */
	0x0C,   /* (     - - 2 3   - - - */
	0x03,   /* )     0 1 - -   - - - */
	0x70,   /* *     - - - -   4 5 6 */
	0x23,   /* +     0 1 - -   - 5 - */
	0x02,   /* ,     - 1 - -   - - - */
	0x20,   /* -     - - - -   - 5 - */
	0x02,   /* .     - 1 - -   - - - */
	0x2A,   /* /     - 1 - 3   - 5 - */
	0x5F,   /* 0     0 1 2 3   4 - 6 */
	0x0C,   /* 1     - - 2 3   - - - */
	0x7A,   /* 2     - 1 - 3   4 5 6 */
	0x7C,   /* 3     - - 2 3   4 5 6 */
	0x2D,   /* 4     0 - 2 3   - 5 - */
	0x75,   /* 5     0 - 2 -   4 5 6 */
	0x77,   /* 6     0 1 2 -   4 5 6 */
	0x1C,   /* 7     - - 2 3   4 - - */
	0x7F,   /* 8     0 1 2 3   4 5 6 */
	0x7D,   /* 9     0 - 2 3   4 5 6 */
	0x50,   /* :     - - - -   4 - 6 */
	0x48,   /* ;     - - - 3   - - 6 */
	0x2C,   /* <     - - 2 3   - 5 - */
	0x60,   /* =     - - - -   - 5 6 */
	0x23,   /* >     0 1 - -   - 5 - */
	0x3A,   /* ?     - 1 - 3   4 5 - */
	0x7E,   /* @     - 1 2 3   4 5 6 */
	0x3F,   /* A     0 1 2 3   4 5 - */
	0x67,   /* b     0 1 2 -   - 5 6 */
	0x53,   /* C     0 1 - -   4 - 6 */
	0x6E,   /* d     - 1 2 3   - 5 6 */
	0x73,   /* E     0 1 - -   4 5 6 */
	0x33,   /* F     0 1 - -   4 5 - */
	0x57,   /* G     0 1 2 -   4 - 6 */
	0x2F,   /* H     0 1 2 3   - 5 - */
	0x0C,   /* I     - - 2 3   - - - */
	0x4E,   /* J     - 1 2 3   - - 6 */
	0x23,   /* K     0 1 - -   - 5 - */
	0x43,   /* L     0 1 - -   - - 6 */
	0x1F,   /* M     0 1 2 3   4 - - */
	0x26,   /* N     - 1 2 -   - 5 - */
	0x5F,   /* O     0 1 2 3   4 - 6 */
	0x3B,   /* P     0 1 - 3   4 5 - */
	0x3D,   /* Q     0 - 2 3   4 5 - */
	0x1B,   /* R     0 1 - 3   4 - - */
	0x75,   /* S     0 - 2 -   4 5 6 */
	0x13,   /* T     0 1 - -   4 - - */
	0x4F,   /* U     0 1 2 3   - - 6 */
	0x6F,   /* V                     */
	0x56,   /* W                     */
	0x70,   /* X     - - - -   4 5 6 */
	0x6D,   /* Y     0 - 2 3   - 5 6 */
	0x7A,   /* Z     - 1 - 3   4 5 6 */
	0x53,   /* [     0 1 - -   4 - 6 */
	0x25,   /* \     0 - 2 -   - 5 - */
	0x5C,   /* ]     - - 2 3   4 - 6 */
	0x10,   /* ^     - - - -   4 - - */
	0x40,   /* _     - - - -   - - 6 */
	0x01,   /* `     0 - - -   - - - */
	0x26,   /* a     - 1 2 -   - 5 - */
	0x67,   /* b     0 1 2 -   - 5 6 */
	0x62,   /* c     - 1 - -   - 5 6 */
	0x6E,   /* d     - 1 2 3   - 5 6 */
	0x62,   /* e     - 1 - -   - 5 6 */
	0x33,   /* f     0 1 - -   4 5 - */
	0x7D,   /* g     0 - 2 3   4 5 6 */
	0x27,   /* h     0 1 2 -   - 5 - */
	0x04,   /* i     - - 2 -   - - - */
	0x44,   /* j     - - 2 -   - - 6 */
	0x23,   /* k                     */
	0x42,   /* l     - 1 - -   - - 6 */
	0x1F,   /* m                     */
	0x26,   /* n     - 1 2 -   - 5 - */
	0x66,   /* o     - 1 2 -   - 5 6 */
	0x3B,   /* p     0 1 - 3   4 5 - */
	0x3D,   /* q     0 - 2 3   4 5 - */
	0x22,   /* r     - 1 - -   - 5 - */
	0x75,   /* s     0 - 2 -   4 5 6 */
	0x63,   /* t     0 1 - -   - 5 6 */
	0x46,   /* u     - 1 2 -   - - 6 */
	0x6F,   /* v                     */
	0x56,   /* w                     */
	0x70,   /* x                     */
	0x2D,   /* y     0 - 2 3   - 5 - */
	0x7A,   /* z     - - - -   - 5 6 */
	0x62,   /* {     - 1 - -   - 5 6 */
	0x02,   /* |     - 1 - -   - - - */
	0x64,   /* }     - - 2 -   - 5 6 */
	0x10,   /* ~     - - - -   4 - - */
	0x00,   /* ^?    - - - -   - - - */
};

/* avoid changing two at once. idles as LCD2 */

#define KEYPAD (              0)
#define LATCH  (         O2_CS1)
#define LCD1   (O2_CS2         )
#define LCD2   (O2_CS2 | O2_CS1)

#define select(what) out_2_change(O2_CS2 | O2_CS1, (what))

#define cu53_clock() cu53_bit(0)
#define cu53_bit(x)  cu_bit(x)

static void
cu53_bits_0123(byte *dp)
{
	byte c = font[*dp];

	cu53_bit(c & 0x01);
	cu53_bit(c & 0x02);
	cu53_bit(c & 0x04);
	cu53_bit(c & 0x08);
}

static void
cu53_bits_456(byte *dp)
{
	byte c = font[*dp];

	cu53_bit(c & 0x10);
	cu53_bit(c & 0x20);
	cu53_bit(c & 0x40);
}

void
cu53_update()
{
	byte *p = keycnt ? buffer : display_2;

	select(LCD1);
	cu53_bit(0);
	cu53_bits_0123(p + 2);
	cu53_bits_0123(p + 3);
	cu53_bits_0123(p + 4);
	cu53_bits_0123(p + 5);
	cu53_bits_0123(p + 6);
	cu53_bits_0123(p + 7);
	cu53_bits_0123(p + 8);
	cu53_bits_0123(p + 9);
	cu53_bit(0);

	select(LCD2);
	cu53_bit(0);
	cu53_bits_0123(display_1 + 0);
	cu53_bits_0123(display_1 + 1);
	cu53_bits_0123(display_1 + 2);
	cu53_bits_0123(display_1 + 3);
	cu53_bits_0123(display_1 + 4);
	cu53_bits_0123(display_1 + 5);
	cu53_bits_0123(p + 0);
	cu53_bits_0123(p + 1);
	cu53_bit(0);

	select(LCD1);
	cu53_bit(0);
	cu53_bits_456(p + 2); cu53_bit(icon_v_u);
	cu53_bits_456(p + 3); cu53_bit(icon_phone);
	cu53_bits_456(p + 4); cu53_bit(icon_clock);
	cu53_bits_456(p + 5); cu53_bit(icon_colon_ur);
	cu53_bits_456(p + 6); cu53_bit(icon_v_d);
	cu53_bits_456(p + 7); cu53_bit(icon_colon_d);
	cu53_bits_456(p + 8); cu53_bit(icon_phone_no);
	cu53_bits_456(p + 9); cu53_bit(icon_mast);
	cu53_bit(1);

	select(LCD2);
	cu53_bit(0);
	cu53_bits_456(display_1 + 0); cu53_bit(icon_colon_ul);
	cu53_bits_456(display_1 + 1); cu53_bit(icon_bar_l);
	cu53_bits_456(display_1 + 2); cu53_bit(icon_star);
	cu53_bits_456(display_1 + 3); cu53_bit(icon_bar_r);
	cu53_bits_456(display_1 + 4); cu53_bit(icon_key);
	cu53_bits_456(display_1 + 5); cu53_bit(icon_book);
	cu53_bits_456(p + 0); cu53_bit(icon_car_d);
	cu53_bits_456(p + 1); cu53_bit(icon_car_u);
	cu53_bit(1);

	select(LCD1);
	cu53_clock();                /* load pulse for the last group */

	select(LCD2);
}

static void
cu53_leds()
{
	cu53_bit(0);           /* not connected */
	cu53_bit(led_call);
	cu53_bit(led_roam);
	cu53_bit(led_keylight);
	cu53_bit(led_serv);
	cu53_bit(led_on);
	cu53_bit(led_lcdlight);
	cu53_bit(led_bright);

	select(LATCH);
	select(LCD2);
}

#define tone(hz) ((0x10000 * (hz) + 7875) / 15750)

const
struct dtmf_mt_tab dtmf_mt_tab[] = {
	{ tone(941), tone(1336) }, /* 0 */
	{ tone(697), tone(1209) }, /* 1 */
	{ tone(697), tone(1336) }, /* 2 */
	{ tone(697), tone(1477) }, /* 3 */
	{ tone(770), tone(1209) }, /* 4 */
	{ tone(770), tone(1336) }, /* 5 */
	{ tone(770), tone(1477) }, /* 6 */
	{ tone(852), tone(1209) }, /* 7 */
	{ tone(852), tone(1336) }, /* 8 */
	{ tone(852), tone(1477) }, /* 9 */
	{ tone(697), tone(1633) }, /* A */
	{ tone(770), tone(1633) }, /* B */
	{ tone(852), tone(1633) }, /* C */
	{ tone(941), tone(1633) }, /* D */
	{ tone(941), tone(1209) }, /* * */
	{ tone(941), tone(1477) }, /* # */
	{tone(1750), tone(1750) }, /* twice, to get full amplitude */
};

static void
cu53_dtmf(byte c)
{
	if (c == 0)
		return;

	if (isdigit(c))
		c -= '0';
	else {
		switch (c) {
		case 'C': c = 10; break;
		case 'S': c = 11; break;
		case 'R': c = 12; break;
		case 'E': c = 13; break;
		case '*': c = 14; break;
		case '#': c = 15; break;
		default:  c = 16; break;
		}
	}
	make_sine(dtmf_sine, cfg.dtmf_gain, 0x40);

	timer_mt(0);
	out_0_set(O0_CCIRC | O0_MTC | O0_MICM);

	/* busywaits DA */

	dtmf_timer_mt(dtmf_mt_tab[c].phinc_1,
	              dtmf_mt_tab[c].phinc_2);

	out_0_clr(O0_CCIRC | O0_MTC | O0_MICM);
	timer_mt(0);
}

/*
 *            B
 *
 *     CL  1 2 3
 * +   STO 4 5 6
 * -   RCL 7 8 9
 *     ENT * 0 #
 *
 *  74C923 gives 0...19 or 0x1F. 1 extra button (marked ?) wireable
 */

static const byte keymap[0x20] = "321C654S987R#0*EB?-+";

static const byte cu53_alphakeys[] =
	"1ABC12DEF23GHI3"
	"4JKL45MNO56PQR6"
	"7STU78VWX89 YZ9"
	"**0-/,.?0##";

#define dcu_read() (ior(PIO_B_DATA) & PB_DCU)

static byte
cu53_keypad()
{
	byte key;

	if (ior(SIO_A_CSR) & SA_DA)     /* key break ? */
		return (0);

	/* key make */

	select(LCD1);
	select(KEYPAD);
	cu53_clock();
	select(LCD1);
	select(LCD2);

	/* photoresistor bit */

	if (dcu_read()) {
		;
	}

	key = 0xF8; /* done after 5 left-shifts */
	do {
		cu53_clock();
		key <<= 1;
		if (dcu_read())
			key++;
	} while (key & 0x80);

	return (keymap[key]);
}

/* 2 last bits from handset */

static byte
cu53_model()
{
	byte model;

	select(LCD1);
	select(KEYPAD);
	cu53_clock();
	select(LCD1);
	select(LCD2);

	model = 0xFE; /* done after 7 left-shifts */
	do {
		cu53_clock();
		model <<= 1;
		if (dcu_read())
			model++;
	} while (model & 0x80);

	return (model & 3);
}

byte
cu53_probe()
{
	byte model = cu53_model();

	switch (model) {

	/* handset missing, just a pulldown on DCU XXX */
	case 0:
		return (0);

	case 1: /* ? */
	case 2: /* ? */
	case 3: /* CU53AN (FI keypad ?) */
	}

	display_2[8] = 'A' + model;

	display_1_len = 6;
	display_2_len = 10;

	alphakeys = cu53_alphakeys;

	cu_keypad = cu53_keypad;
	cu_update = cu53_update;
	cu_leds   = cu53_leds;
	cu_dtmf   = cu53_dtmf;

	return (1);
}

byte
null_keypad()
{
	return (0); /* no keys pressed */
}

extern byte
	cu58af_probe(),
	cu53_probe();

void
cu_probe()
{
	/* AF probe is more anal */

	cu58af_probe() || cu53_probe();

	display_1_end = display_1 + display_1_len;
	display_2_end = display_2 + display_2_len;
}

