
; subset of iomap.h

O1_SRE   = 0x01
O1_SCE   = 0x02
O1_STE   = 0x04
O1_CLK   = 0x08
O1_SD    = 0x10
O1_RAS   = 0x20
O1_TPS   = 0x40

O1_TXOFF = 0x00 ; other one is dummy
O1_TXON  = 0x80 ; XXX BASTARD

O2_DP     = 0x80 ; data to CU53
O2_CLK    = 0x40 ; clock to CU53, I2C SCL to CU58AF
O2_SMEM   = 0x08 ; P8N: select work-ram
O2_ROM0   = 0x04 ; 2 rom banks from ROM0
O2_ROMA14 = 0x01 ; which bank
O2_ROMA15 = 0x02 ; affects only ROM1
O2_ROMA16 = 0x08 ; ROMA16 on P8E (CSMEM elsewhere)

PA_CCIR  = 0xF0 ; FX003 databits
PB_DCU   = 0x08 ; I2C SDA with CU58AF

SA_DA    = 0x20 ; data available from CU53
SA_INT   = 0x20 ; no interrupt from CU58AF

WR0_RESET_TXINT  = 0x28
WR0_RESET_ESCINT = 0x10
WR0_ERROR_RESET  = 0x30

TMR_SEL_LPF = 0x00
TMR_SEL_MT  = 0x40
TMR_SEL_2   = 0x80
TMR_INTTC   = 0x00    ; mode 0, intr on terminal cnt
TMR_ONESHOT = 0x02    ; mode 1, one shot
TMR_RATEGEN = 0x04    ; mode 2, rate generator
TMR_SQWAVE  = 0x06    ; mode 3, square wave
TMR_SWTRIGG = 0x08    ; mode 4, s/w triggered strobe
TMR_HWTRIGG = 0x0A    ; mode 5, h/w triggered strobe
TMR_LATCH   = 0x00
TMR_LSB     = 0x10    ; r/w counter LSB
TMR_MSB     = 0x20    ; r/w counter MSB
TMR_BOTH    = 0x30    ; r/w counter 16 bits, LSB first

PIO_A_DATA = 0x00
PIO_B_DATA = 0x01
PIO_A_CTRL = 0x02
PIO_B_CTRL = 0x03
SIO_A_DATA = 0x10
SIO_B_DATA = 0x11
SIO_A_CSR  = 0x12
SIO_B_CSR  = 0x13
TMR_LPF    = 0x20
TMR_MT     = 0x21
TMR_2      = 0x22
TMR_CTRL   = 0x23
DA_RFC     = 0x30
DA_TPC     = 0x40
AD_RSSI    = 0x50
AD_SQL     = 0x51
AD_BATT    = 0x52
AD_TPC     = 0x53
AD_FPM     = 0x54
AD_RPM     = 0x55
AD_TP4     = 0x56
AD_IN7     = 0x57
OUT_0      = 0x60
OUT_1      = 0x70
OUT_2      = 0x80
WDOG       = 0x90
FX429_DATA = 0xA2
FX429_CSR  = 0xA3
CSMEM      = 0xB0  ; these do not exist on P8N (without mods)
CSPROM     = 0xC0  ;
CSKEY      = 0xD0  ;

MT8888_WD  = 0xC0  ; write data,    RS0=0, A1=0
MT8888_WC  = 0xC1  ; write control, RS0=1, A1=0
MT8888_RD  = 0xC2  ; read data,     RS0=0, A1=1
MT8888_RS  = 0xC3  ; read status,   RS0=1, A1=1

