
/* some strange things are cc workarounds */

#include "head.h"
#include "cfg.h"
#include "cu.h"
#include "iomap.h"

enum {
	NONE,
	SUBMENU,
	MEMORY,
	SPECIAL,

	BOOLEAN,
	TABLE,
	BYTE,

	WORD,
	INTEGER,
	DWORD,
	LONG,

	STRING,
};

enum {
	SPEC_full_reset,
	SPEC_logic,        /* read only */
	SPEC_rfc,
	SPEC_squelch,
	SPEC_squelch_bi,
	SPEC_batt,         /* read only */
	SPEC_decoders,     /* read only */
	SPEC_time,         /* read only */
};

struct setup {
	byte name[8];
	byte type;
	void *addr; /* time for a union ? XXX */
	dword def;
	byte **tab;
};

typedef static const byte * const stables;
stables

speakers_tab[] = {
	"EAr",
	"IntErnAL",
	"ExtErnAL",
	NULL },

sio_fmt_tab[] = {
	"2400 8n", "4800 8n", "9600 8n",
	"2400 8E", "4800 8E", "9600 8E",
	"2400 8o", "4800 8o", "9600 8o",
#if 0
	"cuSt",     /* X1 CLK, external sync needed */
#endif
	NULL },

sql_method_tab[] = {
	"nOISE",
	"rSSI",
	NULL },

logic_tab[] = {
	"P8E",
	"P8N",
	NULL },

dtmf_dec_tab[] = {
	"OFF",
	"8870",
	"8888",
	NULL },

off_on_tab[] = {
	"OFF",
	"On",
	NULL };

static struct setup const

setup_sundry[] = {
	{ "LIGHtS",   BYTE,    &cfg.lights,             60, },
	{ "VOLUME",   BYTE,    &cfg.volume,              1, },
	{ "AF to",    TABLE,   &cfg.af_dest,             0, speakers_tab },
	{ "LPF",      WORD,    &cfg.lpf,              3000, },
	{ "rFc",      SPECIAL, SPEC_rfc,                    },
	{ "GAIn",     BYTE,    &cfg.deviation,          15, },
	{ "dtGAIn",   BYTE,    &cfg.dtmf_gain,         100, },
	{ "ccGAIn",   BYTE,    &cfg.ccir_gain,         100, },
	{ "PrGAIn",   BYTE,    &cfg.afsk_gain,         100, },
	{ "ctGAIn",   BYTE,    &cfg.ctcss_gain,         20, },
	{ "3diGit",   WORD,    &cfg.implied,           433, },
	{ "r cEntEr", DWORD,   &cfg.rx_band_center, 440000, },
	{ "t cEntEr", DWORD,   &cfg.tx_band_center, 440000, },
	{ "t bEGin",  DWORD,   &cfg.tx_band_start,  432000, },
	{ "t End",    DWORD,   &cfg.tx_band_end,    438000, },
	{ "PrEScALE", WORD,    &cfg.prescaler,         128, },
	{ "IF OFFSt", LONG,    &cfg.if_offset,       86512, },
	{ "LOGIC",    SPECIAL, SPEC_logic,                  },
	{ "dEbUG",    WORD,    &debug,                   0, },
	{ "CLOCK",    SPECIAL, SPEC_time,                   },
	{ "FuLrSt",   SPECIAL, SPEC_full_reset,             },
	{ "no OFF",   BOOLEAN, &cfg.stay_on,             0, },
	{ "dtMF dEc", TABLE,   &cfg.dtmf_decoder,        0, dtmf_dec_tab },
	{ "FULduPL",  BOOLEAN, &cfg.fdx,                 0, },
	{ "A bAud",   TABLE,   &cfg.sio_a_fmt,           0, sio_fmt_tab },
	{ "b bAud",   TABLE,   &cfg.sio_b_fmt,           0, sio_fmt_tab },
	{ "LobAtt",   WORD,    &cfg.batt_cutoff,  1670 * 6, },
	{ "r58bis",   STRING,  version + 11,                },
},
setup_status[] = {
	{ "AdrSSI",   BYTE,    &ad_rssi       },
	{ "AdSQL",    BYTE,    &ad_sql        },
	{ "AdbAtt",   SPECIAL, SPEC_batt      },
	{ "AdtPc",    BYTE,    &ad_tpc        },
	{ "AdFPM",    BYTE,    &ad_fpm        },
	{ "AdrPM",    BYTE,    &ad_rpm        },
	{ "AdtP4",    BYTE,    &ad_tp4        },
	{ "AdIn7",    BYTE,    &ad_in7        },
	{ "dEcodErS", SPECIAL, SPEC_decoders  },
},
setup_squelch[] = {
	{ "SQL",      SPECIAL, SPEC_squelch,                },
	{ "dELAY",    WORD,    &cfg.sql_open,          250, },
	{ "tAIL",     WORD,    &cfg.sql_close,         333, },
	{ "HYSt",     BYTE,    &cfg.sql_hyst,            2, },
	{ "SQL bi",   SPECIAL, SPEC_squelch_bi,             },
	{ "tYPE",     TABLE,   &cfg.sql_method,          0, sql_method_tab },
},
setup_packet[] = {
	{ "MYCALL",   STRING,  &cfg.mycall,                 },
	{ "id",       STRING,  &cfg.id,                     },
	{ "tdELAY",   WORD,    &cfg.ax_txdelay,        200, },
},
setup_memories[] = {
	{ "        ", MEMORY,                               },
},
setup_main[] = {
	{ "tPc",      BYTE,    &cfg.tpc,                 0, },
	{ "r FrEQ",   DWORD,   &cfg.rx_freq,        433500, },
	{ "t OFFSEt", LONG,    &cfg.tx_offset,           0, },
	{ "CtCSS",    WORD,    &cfg.ctcss,               0, },
	{ "MEMOrY",   SUBMENU, setup_memories,         100, },
	{ "SQUELCH",  SUBMENU, setup_squelch,  __SIZE(setup_squelch),  },
	{ "StAtuS",   SUBMENU, setup_status,   __SIZE(setup_status),   },
	{ "PAcKEt",   SUBMENU, setup_packet,   __SIZE(setup_packet),   },
	{ "SundrY",   SUBMENU, setup_sundry,   __SIZE(setup_sundry),   },
};

struct setup *setup = setup_main;

byte
	*alphakeys = "00112233445566778899",
	in_setup,
	setup_last,
	setup_ix,
	setup_len = __SIZE(setup_main);

static void
defaults(struct setup *p, word len, byte *old_end)
{
	if (p->type == MEMORY)
		return;

	do {
		if (p->type == SUBMENU) {
			defaults(p->addr, p->def, old_end);
		} else {
			byte *addr = p->addr;

			/* only touched, if cfg.xxx */

			if (addr >= old_end && addr < cfg_END) {
				switch (p->type) {

				case BYTE:
					*addr = p->def;
					break;

				case WORD:
				case INTEGER:
					store_word((word *) addr, p->def);
					break;

				case DWORD:
				case LONG:
					disable();
					*(dword*) addr = p->def;
					restore();
					break;
				}
			}
		}
		++p;
	} while (--len);
}

void
new_defaults()
{
	word keep = cfg.size;

	/* - just garbage
	 * - newer or same version
	 * - older version */

	if (cfg.magic != MAGIC
	 || keep > cfg_END - cfg_START
	 || keep < offsetof(struct cfg, size) + sizeof(cfg.size))
		keep = 0;
	else
	if (keep >= sizeof(cfg))
		return;

	bzero(cfg_START + keep, sizeof(cfg) - keep);

	defaults(setup_main, __SIZE(setup_main), cfg_START + keep);

	cfg.magic = MAGIC;
	cfg.size  = sizeof(cfg);
}

void
full_reset()
{
	disable();
	bzero(bbram, data - bbram);

	new_defaults();
	save_bbram();

	boot();
}

dword
atodw(byte *s)
{
	dword dw = 0;

	while (isdigit(*s)) {
		dw *= 10;
		dw += *s++ - '0';
	}
	return (dw);
}

byte
atob(byte *s)
{
	dword d = atodw(s);

	return ((d > 0xFF) ? 0xFF : d);
}

word
atow(byte *s)
{
	dword d = atodw(s);

	return ((d > 0xFFFF) ? 0xFFFF : d);
}

int
repeat()
{
	if (keycnt) {
		keycnt = 0;
		return (atow(buffer));
	}
	return (1);
}

byte
table_len(struct setup *p)
{
	byte **e = p->tab;

	while (*e)
		++e;

	return (e - p->tab);
}

static byte *
display_word(byte *p, word num)
{
	do {
		*--p = umoddiv_10(&num) + '0';
	} while (num);

	return (p);
}

static byte *
display_dword(byte *p, dword num)
{
	do {
		*--p = ulmoddiv_10(&num) + '0';
	} while (num);

	return (p);
}

static void
show_string(byte *s)
{
	word blank = display_2_len, n = strlen(s);

	if (n > blank)
		n = blank;
	blank -= n;

	bcopy(s, display_2 + blank, n);
}

static void
show_hex(word offset, word num)
{
	byte *d = display_2_end - offset;

	do {
		*--d = hexdig[num & 0xF];
	} while (num >>= 4);
}

static void
show_num(word offset, word n)
{
	display_word(display_2_end - offset, n);
}

static void
show_dword(byte sign, dword n)
{
	if (n > 9999999)
		show_string("???????");
	else
		display_dword(display_2_end, n)[-1] = sign;
}

static void
show_long(long n)
{
	if (n & (1L<<31))
		show_dword('-', -n);
	else
		show_dword(' ', n);
}

static void
show_offset(dword n)
{
	byte sign = ' ';

	if (n & (1L<<31)) {
		n = -n;
		sign = '-';
	}
	while (n > 99999)
		n /= 1000;

	display_dword(display_1_end, n)[-1] = sign;
}

static void
show_table(byte **tab, byte x)
{
	while (x && *tab) {
		++tab;
		--x;
	}
	show_string(*tab ? *tab : "?");
}

static void
show_special(struct setup *p)
{
	switch ((byte) p->addr) {

	case SPEC_logic:
		show_table(logic_tab, logic);
		break;

	case SPEC_rfc:               /* 654 210 */
		show_num(4, ad_rssi);
		show_num(0, RFC_get());
		break;

	case SPEC_squelch:
		show_num(4, cfg.sql_method ? ad_rssi : ad_sql);
		show_num(0, cfg.sql_level);
		break;

	case SPEC_squelch_bi:
		show_num(4, ad_rssi);
		show_num(0, cfg.sql_bi_rssi);
		break;

	case SPEC_batt:
		show_num(0, millivolt(ad_batt));
		break;

	case SPEC_decoders:             /* 65 32 0 */
		show_hex(5, read_8888());
		show_hex(2, read_8870());
		show_hex(0, read_ccir());
		break;

	case SPEC_time:
		show_dword(' ', timex_get());
		break;
	}
}

static void
assign_special(struct setup *p, byte *s)
{
	switch ((byte) p->addr) {

	case SPEC_squelch:
		cfg.sql_level = atob(s);
		break;

	case SPEC_squelch_bi:
		cfg.sql_bi_rssi = atob(s);
		break;

	case SPEC_rfc:
		RFC_set(atob(s));
		break;

	case SPEC_full_reset:
		if (atow(s) == 666)
			full_reset();
		break;
	}
}

static void
bump_special(struct setup *p, int add)
{
	switch ((byte) p->addr) {

	case SPEC_squelch:
		cfg.sql_level += add;
		break;

	case SPEC_squelch_bi:
		cfg.sql_bi_rssi += add;
		break;

	case SPEC_rfc:
		RFC_set(RFC_get() + add);
		break;
	}
}

void
display_setup()
{
	struct setup *p = setup;

	if (p->type != MEMORY)
		p += setup_ix;

	bcopy(p->name, display_1, 8);

	if (keycnt) {
		buffer[keycnt] = alphamode ? '~' : '_';

		if (p->type == MEMORY) {
			switch (keycnt) {
			case 1:
			case 2:
				strcpyx(display_1, "Goto_");
				break;
			case 3:
				strcpyx(display_1, "FLAGS_");
				break;
			case 4:
				strcpyx(display_1, "tonE_");
				break;
			default:
				strcpyx(display_1, "FrEq_");
				break;
			}
		}
		return;
	}
	bzero(display_2, 10);

	switch (p->type) {
	case NONE:
	case SUBMENU:
		break;

	case MEMORY:
		show_dword(' ', memories[setup_ix].rx_freq);
		show_offset(memories[setup_ix].tx_offset);
		icon_key = (memories[setup_ix].ctcss != 0);
		display_2[0] = '0' + setup_ix / 10;
		display_2[1] = '0' + setup_ix % 10;
		break;

	case BOOLEAN:
		show_table(off_on_tab, *(byte *) p->addr);
		break;

	case TABLE:
		show_table(p->tab, *(byte *) p->addr);
		break;

	case STRING:
		show_string(p->addr);
		break;

	case SPECIAL:
		show_special(p);
		break;

	case BYTE:
		show_num(0, *(byte*) p->addr);
		break;
	case WORD:
		show_num(0, *(word*) p->addr);
		break;
	case INTEGER:
		show_long(*(short*) p->addr);

	case DWORD:
		show_dword(' ', *(dword*) p->addr);
		break;
	case LONG:
		show_long(*(long*) p->addr);
		break;
	}
}

/* XXX not here */

void
display()
{
	/* nowhere ? */

	if (cu_update == nop)
		return;

	icon_v_u = 0;
	icon_v_d = 0;
	icon_key = 0;

	if (in_setup) {
		display_setup();

	} else {
		/* XXX */

		bzero(display_1, 8);

		display_1[0] = hexdig[cfg.volume];

		if (led_roam)
			display_word(display_1_end, cfg.tpc);
		else
			display_word(display_1_end, ad_rssi); /* XXX 0...9,10...60 */

		if (keycnt == 0) {
			bzero(display_2, 10);

			icon_v_u = (tx_freq > rx_freq);
			icon_v_d = (tx_freq < rx_freq);

			show_dword(' ', led_roam ? tx_freq : rx_freq);
		}
		icon_key = (cfg.ctcss != 0);
	}
	(*cu_update)();
}

static void
assign(byte *s)
{
	struct setup *p = setup;

	if (p->type != MEMORY)
		p += setup_ix;

	switch (p->type) {
	case NONE:
	case SUBMENU:
		break;

	case MEMORY:
		switch (strlen(s)) {
		case 1:
		case 2:
			setup_ix = atow(s);
		case 0:
			break;
		case 3:
			memories[setup_ix].flags = atob(s);
			break;
		case 4:
			memories[setup_ix].ctcss = atow(s);
			break;
		default:
			if ((memories[setup_ix].rx_freq = atodw(s)) == 0)
				bzero(&memories[setup_ix], sizeof(*memories));
			break;
		}
		break;

	case SPECIAL:
		assign_special(p, s);
		break;

	case STRING:
		strncpyx(p->addr, s, sizeof(cfg_string));
		break;

	case BOOLEAN:
		*(byte*) p->addr = (atow(s) != 0);
		break;

	case TABLE: {
			byte last = table_len(p) - 1;
			byte n = atob(s);

			if (n > last)
				n = last;
			*(byte*) p->addr = n;
		}
		break;

	case WORD:
		store_word(p->addr, atow(s));
		break;

	case BYTE:
		*(byte*) p->addr = atob(s);
		break;

	case DWORD:
		disable();
		*(dword*) p->addr = atodw(s);
		restore();
		break;

	case LONG:
		disable();
		if (*(long*) p->addr > 0)
			*(long*) p->addr = atodw(s); /* keep sign */
		else
			*(long*) p->addr = -atodw(s);
		restore();
		break;
	}
}

static void
bump(int add)
{
	struct setup *p = setup;

	if (p->type != MEMORY)
		p += setup_ix;

	switch (p->type) {
	case NONE:
	case SUBMENU:
		break;

	case MEMORY:
		memories[setup_ix].tx_offset = add;
		break;

	case SPECIAL:
		bump_special(p, add);
		break;

	/* snip last away, or append more */

	case STRING:
		if (add < 0) {
			byte *e = strend(p->addr);

			if (e != p->addr)
				e[-1] = 0;
		} else {
			bzero(buffer, sizeof(buffer));
			strncpyx(buffer, p->addr, sizeof(buffer));
			keycnt = strlen(buffer);
		}
		break;

	case BOOLEAN:
		*(byte*) p->addr = ! *(byte*) p->addr;
		break;

	case TABLE: {
			byte last = table_len(p) - 1;
			byte n = *(byte*) p->addr + add;

			if (n == 0xFF)
				n = last;
			if (n > last)
				n = 0;
			*(byte*) p->addr = n;
		}
		break;

	case WORD:
	case INTEGER:
		store_word(p->addr, *(word*) p->addr + add);
		break;

	case BYTE:
		*(byte*) p->addr += add;
		break;

	case DWORD:
		disable();
		*(dword*) p->addr += add;
		restore();
		break;

	case LONG:
		disable();
		*(long*) p->addr += add;
		restore();
		break;
	}
}

void
key_setup(byte c)
{
	struct setup *p = setup;

	if (p->type != MEMORY)
		p += setup_ix;

	if (isdigit(c)) {
		if (p->type == SUBMENU) {
			setup_last = setup_ix;
			setup_len = p->def;
			setup = p->addr;
			setup_ix = 0;
			return;
		}
		if (alphamode && c == last_key && keycnt)
			c = index(alphakeys, buffer[--keycnt])[1];

		if (keycnt == 0)
			bzero(buffer, sizeof(buffer));

		if (keycnt < display_2_len)
			buffer[keycnt++] = c;

		alphamode = (p->type == STRING);
		return;
	}
	alphamode = 0;

	switch (c) {
	case 'C':
		if (keycnt) {
			buffer[keycnt] = 0;       /* cursor */
			buffer[--keycnt] = 0;     /* character */
			break;
		}
		if (setup != setup_main) {
			setup_len = __SIZE(setup_main);
			setup = setup_main;
			setup_ix = setup_last;
			break;
		}
	case 'E':
		in_setup = 0;
		save_bbram();
		break;

	case '*':
		keycnt = 0;
		if (setup_ix == 0)
			setup_ix = setup_len;
		setup_ix--;
		break;

	case '#':
		if (keycnt) {
			buffer[keycnt] = 0;
			keycnt = 0;
			assign(buffer);
			break;
		}
		setup_ix++;
		if (setup_ix >= setup_len)
			setup_ix = 0;
		break;

	case '+':
		bump(+repeat());
		break;
	case '-':
		bump(-repeat());
		break;

	case 'S':
	case 'R':
		break;
	}
}

/* XXX a stack of positions or something needed */

void
quick_setup(byte key)
{
	switch (key) {

	case '1':
	case '4':
		setup = setup_squelch;
		setup_ix = 0;
		setup_len = __SIZE(setup_squelch);

		key_setup((key <= '3') ? '+' : '-');
		break;
	}
}

