
#include "head.h"
#include "pcb.h"
#include "io.h"

#asm

	include asm.inc

	.text

;----------------------------------------------------------------------
	export _outb_crtc
	export _outw_crtc

_outb_crtc:           ; void outb_crtc(reg, value);
	mov dx, # CRTC    ; Address register
	out dx, al        ; ARG1
	ARG2 al
	inc dx            ; value register
	out dx, al
	ret

_outw_crtc:           ; void outw_crtc(reg, word value);
	mov ah, al        ; ARG1, index of MSByte
	inc al            ; index of LSByte
	ARG2 bx           ; word value

	mov dx, # CRTC    ; Address register
	out dx, al        ; index LSByte
	mov al, bl
	inc dx            ; value register
	out dx, al

	mov al, ah        ; index MSByte
	dec dx            ; Address register
	out dx, al
	mov al, bh
	inc dx            ; value register
	out dx, al
	ret

	export _clear_screen
	export _update_row
	export _putc_screen

_clear_screen:
	push es
	mov ax, # SCREEN
	mov es, ax
	xor di, di
	mov _cursor, di
	mov ax, # 0x0020  ; XXX attribute and character
	mov cx, # 40 * 16
	rep
	stosw
	pop es
	ret

_update_row:          ; void update_row(rownum, string);
	ARG2 si
	mov cx, # 40      ; character columns
	mul cl            ; ARG1 (max 255) * cl -> ax
	shl ax, 1         ; char and attribute
	mov di, ax        ; byte offset in frame buffer
	push es
	mov ax, # SCREEN
	mov es, ax
	mov ah, # 8       ; XXX attribute
.7:
	lodsb             ; character
	stosw             ; with attribute
	loop .7           ; each column
	pop es
	ret

_putc_screen:
	xor ah, ah        ; XXX attribute
	push es
	les di, _cursor
	stosw
	mov _cursor, di
	pop es
	ret

;----------------------------------------------------------------------
	.data

_cursor:
	.word 0
	.word SCREEN

;----------------------------------------------------------------------
	.bss
