
#define VERSION "@(#)Aplicom 80C188XL 256 kB rom"

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;

#define XTAL   16256000

#define CPUCLK (XTAL   / 2)
#define TMRCLK (CPUCLK / 4)

/*
 * LCS  none
 * MCS0 128 kB: 64 kB code and 64 kB data/bss/stack
 * MCS1 128 kB: unused
 * MCS2 128 kB: unused
 * MCS3 128 kB: 64 kB display ram
 * UCS  256 kB: rom
 */
#define _CS 0
#define _DS 0x1000

#define SCREEN 0x6000
#define ROM    0xC000


/* pusha
 * push ds
 * push es */

#ifdef __FIRST_ARG_IN_AX__
#define IREGS_1 junk,
#else
#define IREGS_1
#endif
#define IREGS_ES 0
#define IREGS_DS 2
#define IREGS_DI 4
#define IREGS_SI 6
#define IREGS_BP 8
#define IREGS_SP 10
#define IREGS_BX 12
#define IREGS_DX 14
#define IREGS_CX 16
#define IREGS_AX 18
#define IREGS_IP 20
#define IREGS_CS 22
#define IREGS_FL 24
#define IREGS_SZ 26

/*                    0  2   4  6  8  10 12 14 16 18  20 22 24 */

#define IREGS IREGS_1 es,ds, di,si,bp,sp,bx,dx,cx,ax, ip,cs,flags

#define _P(args) ()

extern void
	outw _P((word port, word)),
	outb _P((word port, byte)),
	outb_crtc _P((byte reg, byte)),
	outw_crtc _P((byte reg, word)),
	disable _P((void)),
	enable _P((void)),
	splx _P((word opri));

extern word
	inw _P((word port)),
	inb _P((word port)),
	spl_up _P((word npri));

extern dword
	linear_address _P((word offset)); /* of ds:offset */

#define spl7() spl_up(7) /* accept priorities 0-7 (all) */
#define spl6() spl_up(6)
#define spl5() spl_up(5)
#define spl4() spl_up(4)
#define spl3() spl_up(3)
#define spl2() spl_up(2)
#define spl1() spl_up(1)
#define spl0() spl_up(0) /* accept only priority 0 */

extern byte
	hexdig[16];

extern word
	timef,
	time;

extern dword
	timex;

